# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

# We need to patch the test suite if we have old versions of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.62) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-Test-Base
Version:	0.60
Release:	3.%{__distinit}%{__distvers}
Summary:	Data Driven Testing Framework
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Test-Base/
Source0:	http://search.cpan.org/CPAN/authors/id/I/IN/INGY/Test-Base-%{version}.tar.gz
Patch0:		Test-Base-0.60-dont-need-583.patch
Patch1:		Test-Base-0.60-old-Test-More.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(Carp)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(Filter::Util::Call)
BuildRequires:	perl(LWP::Simple)
BuildRequires:	perl(MIME::Base64)
BuildRequires:	perl(Spiffy) >= 0.30
BuildRequires:	perl(Test::Deep)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Tester)
BuildRequires:	perl(Text::Diff) >= 0.35
BuildRequires:	perl(YAML)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Data::Dumper)
Requires:	perl(File::Path)
Requires:	perl(Filter::Util::Call)
Requires:	perl(MIME::Base64)
Requires:	perl(Spiffy) >= 0.30
Requires:	perl(Test::Deep)
Requires:	perl(LWP::Simple)
Requires:	perl(Text::Diff) >= 0.35
Requires:	perl(YAML)

# Module::Install::TestBase is an enhancement to Module::Install and it requires
# Module::Install::Base, which is bundled with Module::Install; we don't want to
# pull in Module::Install for all Test::Base users, so drop the hard dependency
# - anyone using Module::Install::TestBase must by definition have
# Module::Install and hence Module::Install::Base anyway.
%global reqfilt /bin/sh -c "%{__perl_requires} | sed -e '/^perl(Module::Install::Base)$/d'"
%define __perl_requires %{provfilt}
%global __requires_exclude ^perl\\(Module::Install::Base\\)

%description
Testing is usually the ugly part of Perl module authoring. Perl gives you a
standard way to run tests with Test::Harness, and basic testing primitives
with Test::More. After that you are pretty much on your own to develop a
testing framework and philosophy. Test::More encourages you to make your
own framework by subclassing Test::Builder, but that is not trivial.

Test::Base gives you a way to write your own test framework base class that
*is* trivial.

%prep
%setup -q -n Test-Base-%{version}

# Don't really need perl ≥ 5.8.3, despite what Module::Install thinks
%patch0 -p1

# Need to tweak the test suite if we have Test::More < 0.62
%if %{old_test_more}
%patch1 -p1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} \; 2>/dev/null
%{_fixperms} %{buildroot}

%check
# t/deep.t fails with 5.8.5 but not earlier or later versions...
%if %(perl -e 'print $] == 5.008005 ? 1 : 0;')
mv t/deep.t .
%endif
make test
%if %(perl -e 'print $] == 5.008005 ? 1 : 0;')
mv deep.t t/
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README
%{perl_vendorlib}/Module/
%{perl_vendorlib}/Test/
%{_mandir}/man3/Module::Install::TestBase.3pm*
%{_mandir}/man3/Test::Base.3pm*
%{_mandir}/man3/Test::Base::Filter.3pm*

%changelog
* Mon Sep 26 2011 Paul Howarth <paul@city-fan.org> - 0.60-3
- Import from Fedora

* Wed Jun 29 2011 Marcela Mašláňová <mmaslano@redhat.com> - 0.60-2
- Perl mass rebuild

* Sat May 14 2011 Iain Arnell <iarnell@gmail.com> - 0.60-1
- Update to latest upstream version
- Clean up spec for modern rpmbuild

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.59-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 22 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.59-2
- Rebuild to fix problems with vendorarch/lib (#661697)

* Mon Dec 13 2010 Steven Pritchard <steve@kspei.com> - 0.59-1
- Update to 0.59

* Thu May 06 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.58-4
- Mass rebuild with perl-5.12.0

* Fri Dec  4 2009 Stepan Kasal <skasal@redhat.com> - 0.58-3
- Rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.58-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sun May 17 2009 Steven Pritchard <steve@kspei.com> - 0.58-1
- Update to 0.58
- BR Test::Deep and Test::Tester

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.55-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Dec 10 2008 Steven Pritchard <steve@kspei.com> - 0.55-1
- Update to 0.55
- Explicitly BR Test::More >= 0.62
- BR YAML

* Thu Mar 06 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.54-3
- Rebuild for new perl

* Sat Jul 07 2007 Steven Pritchard <steve@kspei.com> - 0.54-2
- BR Test::More

* Mon Jul 02 2007 Steven Pritchard <steve@kspei.com> - 0.54-1
- Update to 0.54

* Wed Apr 18 2007 Steven Pritchard <steve@kspei.com> - 0.53-2
- BR ExtUtils::MakeMaker

* Sat Dec 09 2006 Steven Pritchard <steve@kspei.com> - 0.53-1
- Update to 0.53
- Use fixperms macro instead of our own chmod incantation

* Sat Sep 16 2006 Steven Pritchard <steve@kspei.com> - 0.52-2
- Fix find option order

* Sat Jul 01 2006 Steven Pritchard <steve@kspei.com> - 0.52-1
- Update to 0.52

* Mon May 08 2006 Steven Pritchard <steve@kspei.com> - 0.50-2
- Add explicit dependencies for Text::Diff and LWP::Simple

* Thu May 04 2006 Steven Pritchard <steve@kspei.com> - 0.50-1
- Specfile autogenerated by cpanspec 1.65
- Remove explicit BR: perl and Requires: perl(Spiffy)
